config/routes.rb
Rails.application.routes.draw do
  resources :comments
  resources :analyses
  resources :static_pages
  root 'static_pages#index'
  resources :consultations  do
    get "allindex", on: :collection
  end
  get 'micontroller/allindex'
  devise_for :patients do
  end
  get "/static_pages/index" => "static_pages#index"
  #PATIENT INFORMATION
  match '/patient', to: 'patients#show', via: 'get'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/consultation.rb
class Consultation < ApplicationRecord
  validates :doctor, presence: { message: ": El nombre del doctor no puede estar vacío" }
  mount_uploader :consultationPicture, ConsultationimageUploader
  belongs_to :patient
end

app/controllers/consultations_controller.rb
class ConsultationsController < ApplicationController
  before_action :authenticate_patient! 
  before_action :set_consultation, only: [:show, :edit, :update, :destroy]

  # GET /consultations
  # GET /consultations.json
  def indexz
    @consultations = current_patient.consultations.order('created_at DESC')
  end
  # GET /consultations/1
  # GET /consultations/1.json
  def show
    respond_to do |format|
      format.html
      format.json
      format.pdf { render template: 'consultations/pdfView', pdf: 'Consulta'}
    end
  end

  # GET /consultations/new
  def new
    @consultation = Consultation.new
  end

  # GET /consultations/1/edit
  def edit
  end

  def allindex
    
  end
  # POST /consultations
  # POST /consultations.json
  def create
    @consultation = Consultation.new(consultation_params)
    @consultation.patient_id = current_patient.id
    respond_to do |format|
      if @consultation.save
        format.html { redirect_to @consultation, notice: 'Consulta creada con éxito.' }
        format.json { render :show, status: :created, location: @consultation }
      else
        format.html { render :new }
        format.json { render json: @consultation.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /consultations/1
  # PATCH/PUT /consultations/1.json
  def update
    respond_to do |format|
      if @consultation.update(consultation_params)
        format.html { redirect_to @consultation, notice: 'Consulta editada.' }
        format.json { render :show, status: :ok, location: @consultation }
      else
        format.html { render :edit }
        format.json { render json: @consultation.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /consultations/1
  # DELETE /consultations/1.json
  def destroy
    @consultation.destroy
    respond_to do |format|
      format.html { redirect_to static_pages_path, notice: 'Consulta eliminada con éxito.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_consultation
      @consultation = Consultation.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def consultation_params
      params.require(:consultation).permit(:date, :reason, :doctor, :specialty, :prescription, :observations, :patient_id, :consultationPicture)
    end
end

app/helpers/consultations_helper.rb
module ConsultationsHelper
end

app/views/consultations/_form.html.erb
<%= form_with(model: consultation, local: true) do |f| %>
  <% if consultation.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(consultation.errors.count, "error(es)") %></h2>

      <ul>
      <% consultation.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <p>Fecha</p>
    <%= f.date_select :date %>
  </div>

  <div class="field">
    <p>Asunto</p>
    <%= f.text_area :reason %>
  </div>

  <div class="field">
    <p>Doctor</p>
    <%= f.text_field :doctor %>
    <!--<%= @consultation.errors[:doctor].any? ? @consultation.errors[:doctor].to_s[/\w([^"]*)/] : "" %>
    -->
  </div>

  <div class="field">
    <p>Especialidad</p>
    <%= f.text_field :specialty %>
  </div>

  <div class="field">
    <p>Prescripción</p>
    <%= f.text_area :prescription %>
  </div>

  <div class="field">
    <p>Observaciones</p>
    <%= f.text_area :observations %>
  </div>

  <div class="field">
    <%= f.label :consultationPicture, 'Imagen de la Consulta' %><br />
    <%= f.file_field :consultationPicture %>
  </div>

  <div class="actions">
    <%= f.submit value = "Crear consulta"%>
  </div>


<% end %>

app/views/consultations/edit.html.erb
<h1>Editing Consultation</h1>

<%= render 'form', consultation: @consultation %>

<%= link_to 'Mostrar', @consultation %> |
<%= link_to 'Atrás', { controller: "static_pages" } %>

app/views/consultations/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Consultas</h1>

<table>
  <thead>
    <tr>
      <th>Fecha</th>
      <th>Asunto</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @consultations.each do |consultation| %>
      <tr>
        <td><%= consultation.date %></td>
        <td><%= consultation.reason %></td>
        <td><%= link_to 'Mostrar', consultation %></td>
        <td><%= link_to 'Editar', edit_consultation_path(consultation) %></td>
        <td><%= link_to 'Eliminar',consultation,method: :delete, data: { confirm: '¿Está seguro?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<button><%= link_to 'Nueva consulta', new_consultation_path %></button>

app/views/consultations/new.html.erb
<h1>Nueva consulta</h1>

<%= render 'form', consultation: @consultation %>

<%= link_to 'Atrás', { controller: "static_pages" } %>

app/views/consultations/pdfView.pdf.erb
<head>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1">
</head>
<p>
  <strong>Fecha:</strong>
  <%= @consultation.date %>
</p>

<p>
  <strong>Asunto:</strong>
  <%= @consultation.reason %>
</p>

<p>
  <strong>Doctor:</strong>
  <%= @consultation.doctor %>
</p>

<p>
  <strong>Especialidad:</strong>
  <%= @consultation.specialty %>
</p>

<p>
  <strong>Prescripción:</strong>
  <%= @consultation.prescription %>
</p>

<p>
  <strong>Observaciones:</strong>
  <%= @consultation.observations %>
</p>

app/views/consultations/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Fecha:</strong>
  <%= @consultation.date %>
</p>

<p>
  <strong>Asunto:</strong>
  <%= @consultation.reason %>
</p>

<p>
  <strong>Doctor:</strong>
  <%= @consultation.doctor %>
</p>

<p>
  <strong>Especialidad:</strong>
  <%= @consultation.specialty %>
</p>

<p>
  <strong>Prescripción:</strong>
  <%= @consultation.prescription %>
</p>

<p>
  <strong>Observaciones:</strong>
  <%= @consultation.observations %>
</p>

<p>
  <strong>Foto:</strong>
  <img src="<%= @consultation.consultationPicture.thumb.url %>">
</p>


<%= link_to 'Generar documento', consultation_url(format: :pdf) %> |
<%= link_to 'Editar', edit_consultation_path(@consultation) %> |
<%= link_to 'Atrás', { controller: "static_pages" } %>